#! /usr/bin/python

import sys, traceback
from modules.helpers.calcerror import CalculationError

VER_NUM = 0.1

def printVerUsage():
    print("Version", VER_NUM)
    print("Usage:", sys.argv[0], "module [module params]")
    
def tryImportModule(mod):
    try:
        module = __import__("modules."+mod)
        
    except ImportError:
        return None
        
    return module
    
def tryPrintDoc(mod):
    try:
        mod.printDoc()
    except AttributeError as error:
        print("Module \"" + sys.argv[1] + "\" has no documentation availible")
    
def fail(noMod = False):
    printVerUsage()
    if noMod:
        print("Module not found!")
    sys.exit(1)
        

if len(sys.argv) >= 3:
        mod = tryImportModule(sys.argv[1])
        if not mod:
            fail(True)
        try:
            print("Answer:", mod.doCalc(*sys.argv[2:]))
        except CalculationError as error:
            print(error)
            tryPrintDoc(mod)
        
    
elif len(sys.argv) == 2:
    mod = tryImportModule(sys.argv[1])
    if not mod:
        fail(True)
    tryPrintDoc(mod)

else:
    fail()